UNIT uTaschenlampe;
(* ******************************************************************** *)
(* K L A S S E : TTaschenlampe                                          *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.1                                                    *)
(* Autor       : S. Spolwig, 2005                                             *)
(* Beschreibung: Die Klasse abstrahiert und modelliert eine Taschenlampe*)
(*               mit einer diskreten Lampe                              *)
(*                                                                      *)
(* Compiler    : Delphi 6.0                                             *)
(* Aenderungen : -                                                      *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================

uses uLampe;

type
  TTaschenlampe = class(TObject)
   private
    Lampe    : TLampe;      // Elektriker-Deutsch, vulgo Glhbirne o..
    Batterie : Boolean;
    Schalter : boolean;

   public
    constructor Create;
    procedure   Einschalten;
    procedure   Ausschalten;
    function    Leuchtet : boolean;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    :
Bezugsklassen : ...........      import:


Methoden
--------

Create
  Auftrag: Erzeugen und Anfangswerte initialisieren
  vorher : -
  nachher: Batterie ist true; Schalter false

Einschalten
  Auftrag: Schalter auf true
  vorher : -
  nachher: done

Ausschalten
  Auftrag: Schalter auf false
  vorher : -
  nachher: done

Leuchtet
  Anfrage: ob die Taschenlampe 'brennt'
  vorher :
  nachher: leuchtet, wenn Lampe Licht gibt, Batterie OK und Schalter auf EIN 

--------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TTaschenlampe.Create;
// --------------------------------------------------------------------
begin
  inherited Create;
  Lampe := TLampe.Create;
  Batterie  := true; // drin und ok
  Schalter  := false // aus
end;


procedure TTaschenlampe.Einschalten;
// --------------------------------------------------------------------
begin
  Schalter := true;
  Lampe.Leuchten;
end;

procedure TTaschenlampe.Ausschalten;
// --------------------------------------------------------------------
begin
  Schalter := false;
end;

function TTaschenlampe.Leuchtet : boolean;
// --------------------------------------------------------------------
begin
  Result := (Lampe.GetLicht = true) AND (Batterie = true) AND (Schalter = true)
end;

END. // -------- UNIT -------------
