UNIT uBatterie;
(* ******************************************************************** *)
(* K L A S S E : TBatterie                                              *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.2                                                    *)
(* Autor       :                                                        *)
(* Beschreibung: Die Klasse abstrahiert und modelliert eine Batterie    *)
(*               mit 1.5 V                                              *)
(* Compiler    : Delphi 6.0                                             *)
(* Aenderungen : -                                                      *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================

type
  TBatterie = class(TObject)
   private
    Spannung  : double;
   public
    constructor Create;
    function    GetSpannung : double;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    :
Bezugsklassen : ...........      import:


Methoden
--------
Create
  Auftrag: Erzeugen und Anfangsspannung festlegen
  vorher :
  nachher: Spannung ist 1.5 V.

Get...
  Auftrag: Attribut aus dem Objekt lesen
  vorher : Spannung ist init.
  nachher: -

--------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TBatterie.Create;
// --------------------------------------------------------------------
begin
  inherited Create;
  Spannung := 1.5;
end;


function TBatterie.GetSpannung : double;
// --------------------------------------------------------------------
begin
  Result := Spannung;
end;


END. // -------- UNIT -------------
