unit uFenster;
// ***********************************************************************
// K L A S S E : TLampenGUI
// -----------------------------------------------------------------------
// Version  : 1.2
// Autor    : S. Spolwig, 2005
//            nach einer Vorlage von Christian Steinbrucker, OSZ TIEM, Berlin
// Aufgabe  : GUI fuer die Taschenlampe
// Compiler : DELPHI 6
// Aenderung: V. 2.0 - 26-AUG-05   Die Fachklasse TTaschenlampe ausgelagert
//                                 gem MVC-Pattern
//               2.1 - 27-AUG-05   TLampe ausgelagert
//               1.2 - 06-SEP-05   TBatterie ausgelagert, liefert konst. Spannung 
//                                 TGluehlampe - Unterklasse
// ***********************************************************************

interface
// =======================================================================
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,ComCtrls,
  uTaschenlampe;

type
  TLampenGUI = class(TForm)
    GehaeusePnl   : TPanel;
    LampenShp     : TShape;
    AufschriftLbl : TLabel;
    SchalterUpDown: TUpDown;   
    
    procedure FormCreate(Sender: TObject);
    procedure SchalterUpDownClick(Sender: TObject; Button: TUDBtnType);

  private
     procedure Darstellen(TLa : TTaschenlampe);
  end;

var
  LampenGUI   : TLampenGUI;
  Taschenlampe: TTaschenlampe;

implementation
{$R *.dfm}
// =======================================================================

procedure TLampenGUI.FormCreate(Sender: TObject);
// -----------------------------------------------------------------------
begin
  Taschenlampe := TTaschenlampe.Create;
end;

procedure TLampenGUI.SchalterUpDownClick(Sender: TObject; Button: TUDBtnType);
// -----------------------------------------------------------------------
begin
  if (SchalterUpDown.Position >= 1)
  then
    begin
      Taschenlampe.Einschalten;
      SchalterUpDown.Position := 0
    end
  else Taschenlampe.Ausschalten;
  Darstellen (Taschenlampe);
end;


Procedure TLampenGUI.Darstellen(TLa: TTaschenlampe);
// -----------------------------------------------------------------------
Begin
  if TLa.Leuchtet = true
  then LampenShp.brush.color := clyellow
  else LampenShp.brush.color := clBlack;
End;


END. // -------- UNIT -------------.
