UNIT uGluehlampe;
(* ******************************************************************** *)
(* K L A S S E : TGluehlampe                                            *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.2                                                    *)
(* Autor       : S. Spolwig, 2005                                       *)
(* Beschreibung: Die Klasse abstrahiert und modelliert eine Lampe, die  *)
(*               zum Leuchten eine Spannung > 0 braucht                 *)
(*                                                                      *)
(* Compiler    : Delphi 6.0                                             *)
(* Aenderungen : -                                                      *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================
uses uLampe;

type
  TGluehlampe = class(TLampe)   // erbt alles von TLampe
   private
    Spannung  : double;
   public
    constructor Create;
    procedure   SetSpannung (u : double);
    function    GetSpannung : double;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : TLampe
Bezugsklassen : -     import:


Methoden
--------
Create
  Auftrag: Lampe erzeugen und init.
  vorher : -
  nachher: Spannung ist 0 V


SetSpannung
  Auftrag: Lampe mit Strom versorgen und leuchten lassen
  vorher : -
  nachher: Leuchtet oder nicht

Get...
  Auftrag: Attribut aus dem Objekt lesen
  vorher : Objekt ist init.
  nachher: -
--------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TGluehlampe.Create;
// --------------------------------------------------------------------
begin
  inherited Create;
  Spannung  := 0;  
end;


procedure TGluehlampe.SetSpannung (u : double);
// --------------------------------------------------------------------
begin
  Spannung := u;
  if Spannung > 0
  then Leuchten;
end;


function TGluehlampe.GetSpannung : double;
// --------------------------------------------------------------------
begin
  Result := Spannung;
end;

END. // -------- UNIT -------------
