UNIT uTaschenlampe;
(* ******************************************************************** *)
(* K L A S S E : TTaschenlampe                                          *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.2                                                    *)
(* Autor       :                                                        *)
(* Beschreibung: Die Klasse abstrahiert und modelliert eine Taschenlampe*)
(*               mit einer diskreten Gluehlampe und einer Batterie.     *)
(*                                                                      *)
(* Compiler    : Delphi 6.0                                             *)
(* Aenderungen : V. 1.2  -          TGluehlampe, TBatterie              *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================

uses uGluehLampe, uBatterie;     //////////////

type
  TTaschenlampe = class(TObject)
   private
    Lampe    : TGluehLampe;     ///////////////
    Batterie : TBatterie;       ///////////////
//////    Lampe    : TLampe;
//////    Batterie : Boolean;
    Schalter : boolean;

   public
    constructor Create;
    procedure Einschalten;
    procedure Ausschalten;
    function  Leuchtet : boolean;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    :
Bezugsklassen : ...........      import:


Methoden
--------
Create
  Auftrag: Erzeugen und initialisieren
  vorher :
  nachher:

Einschalten
  Auftrag: Schalter auf ein und Lampe mit Batteriespannung versorgen
  vorher :
  nachher: done

Ausschalten
  Auftrag: Schalter auf aus und Spannung an der Lampe auf 0
  vorher :
  nachher: done

Leuchtet
  Anfrage: ob die Taschenlampe 'brennt'
  vorher :
  nachher: leuchtet, wenn Lampe Licht gibt und Lampenspannnung > 0 und
           Schalter auf EIN

--------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TTaschenlampe.Create;
// --------------------------------------------------------------------
begin
  inherited Create;
  Lampe    := TGluehLampe.Create;         //////////////////
  Batterie := TBatterie.Create;
/////  Lampe    := TLampe.Create;
//  Batterie  := true; // drin und ok          /////////////
  Schalter  := false // aus
end;


procedure TTaschenlampe.Einschalten;
// --------------------------------------------------------------------
begin
  Schalter := true;
  Lampe.SetSpannung(Batterie.GetSpannung);         //////////////
//  Lampe.Leuchten;     //wenn nicht durchgebrannt ///////////
end;


procedure TTaschenlampe.Ausschalten;
// --------------------------------------------------------------------
begin
  Schalter := false;
  Lampe.SetSpannung(0); 
end;


function TTaschenlampe.Leuchtet : boolean;
// --------------------------------------------------------------------
begin
  Result := (Lampe.GetLicht = true) AND (Lampe.GetSpannung > 0) AND (Schalter = true);
end;                                     ////////////////


END. // -------- UNIT -------------
