UNIT uBatterie;
(* ******************************************************************** *)
(* K L A S S E : TBatterie                                              *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.3                                                    *)
(* Autor       : S. Spolwig, 2005                                       *)
(* Beschreibung: Die Klasse abstrahiert und modelliert eine Batterie    *)
(*               mit 1.5 V                                              *)
(* Aenderungen : V. 1.3 - 01-OKT-5  Spannung sinkt bei Stromentnahme    *)
(* ******************************************************************** *)

INTERFACE
// =======================================================================

type
  TBatterie = class(TObject)
   private
    Spannung : double;              // eff. Spannung

   public
    constructor Create;
    function    GetSpannung : double;
  end;

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : -
Bezugsklassen :      import:


Methoden
--------
Create
  Auftrag: Erzeugen und Anfangsspannung festlegen
  vorher :
  nachher: Spannung ist 1.5 V.

Get...
  Anfrage: nach der Spannung
  vorher : Spannung ist init.
  nachher: Spannung ist um x.x V gesunken

--------------------------------------------------------------------- *)


IMPLEMENTATION
// ====================================================================

constructor TBatterie.Create;
// --------------------------------------------------------------------
begin
  inherited Create;
  Spannung := 1.5;
end;


function TBatterie.GetSpannung : double;
// --------------------------------------------------------------------
begin
  Result := Spannung;
  if (Spannung >= 0.001 ) // 
  then Spannung := (Spannung - 0.001);
end;

END. // -------- UNIT -------------
